#include <stdio.h>
#include <stdlib.h>
int minRaz(int n,int a[]){
    int m=abs(a[0]-a[1]);
    for(int i=0;i<n;i++)
        for(int j=1;j<n;j++)
            if(i==j)
                continue;
            else
                if(abs(a[i]-a[j])<m)
                    m=abs(a[i]-a[j]);
    return m;
}
int minimum(int n,int a[]){
    int m=a[0];
    for(int i=1;i<n;i++)
        if(a[i]<m)
            m=a[i];
    return m;
}
int main()
{
    int t;
    scanf("%d",&t);
    int r[t],nn,mm,raz,min,ind=0,ind1=0;
    for(int i=0;i<t;i++){
        scanf("%d%d",&nn,&mm);
        int n[nn],m[mm];
        for(int j=0;j<nn;j++)
            scanf("%d",&n[j]);
        for(int j=0;j<mm;j++)
            scanf("%d",&m[j]);
        raz=minRaz(nn,n);
        min=minimum(nn,n);
        for(int j=0;j<nn;j++)
            if((n[j]-min)%raz!=0){
                ind=1;
                break;
            }
        for(int j=0;j<mm;j++)
            if((m[j]-min)%raz==0){
                ind1=1;
                break;
            }
        if(ind==0 && ind1==0)
            r[i]=1;
        else
            r[i]=0;
        ind=0;
        ind1=0;
    }
    for(int i=0;i<t;i++)
        printf("%d\n",r[i]);
    return 0;
}